/**
 * Generated by Apache Royale Compiler from org/apache/royale/createjs/CheckBox.as
 * org.apache.royale.createjs.CheckBox
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.createjs.CheckBox');

goog.require('org.apache.royale.core.IToggleButtonModel');
goog.require('org.apache.royale.createjs.core.CreateJSBase');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.graphics.SolidColor');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.createjs.core.CreateJSBase}
 */
org.apache.royale.createjs.CheckBox = function() {
  org.apache.royale.createjs.CheckBox.base(this, 'constructor');
};
goog.inherits(org.apache.royale.createjs.CheckBox, org.apache.royale.createjs.core.CreateJSBase);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.createjs.CheckBox', org.apache.royale.createjs.CheckBox);


/**
 * @private
 * @type {createjs.Shape}
 */
org.apache.royale.createjs.CheckBox.prototype.checkMark;


/**
 * @private
 * @type {createjs.Text}
 */
org.apache.royale.createjs.CheckBox.prototype.checkBoxLabel;


/**
 * @private
 * @type {createjs.Shape}
 */
org.apache.royale.createjs.CheckBox.prototype.checkBackground;


/**
 * @royaleignorecoercion org.apache.royale.core.WrappedHTMLElement
 * @protected
 * @override
 */
org.apache.royale.createjs.CheckBox.prototype.createElement = function() {
  this.checkMark = new createjs.Shape(null);
  this.checkMark.name = 'checkmark';
  this.checkBoxLabel = new createjs.Text('checkbox', '20px Arial');
  this.checkBoxLabel.name = 'label';
  this.checkBoxLabel.textAlign = 'left';
  this.checkBoxLabel.textBaseline = 'middle';
  this.checkBackground = new createjs.Shape(null);
  this.checkBackground.name = 'checkbackground';
  var /** @type {createjs.Container} */ container = new createjs.Container();
  this.element = container;
  container.name = 'checkbox';
  container.addChild(this.checkBackground);
  container.addChild(this.checkBoxLabel);
  container.addChild(this.checkMark);
  this.checkBoxLabel.addEventListener("click", org.apache.royale.utils.Language.closure(this.clickHandler, this, 'clickHandler'));
  this.checkMark.addEventListener("click", org.apache.royale.utils.Language.closure(this.clickHandler, this, 'clickHandler'));
  this.positioner = this.element;
  return this.element;
};


/**
 * @private
 * @type {string}
 */
org.apache.royale.createjs.CheckBox.prototype._fontName = "18px Arial";


/**
 * @asprivate
 * @royaleignorecoercion createjs.Container
 * @protected
 * @override
 */
org.apache.royale.createjs.CheckBox.prototype.redrawShape = function() {
  var /** @type {string} */ color = "black";
  if (this.textColor != null) {
    color = this.convertColorToString(org.apache.royale.utils.Language.as(this.textColor, org.apache.royale.graphics.SolidColor).color, 1.0);
  }
  var /** @type {string} */ fillColor = "DeepSkyBlue";
  var /** @type {number} */ fillAlpha = 1.0;
  if (this.fill != null) {
    fillAlpha = org.apache.royale.utils.Language.as(this.fill, org.apache.royale.graphics.SolidColor).alpha;
    fillColor = this.convertColorToString(org.apache.royale.utils.Language.as(this.fill, org.apache.royale.graphics.SolidColor).color, fillAlpha);
  }
  var /** @type {createjs.Text} */ label = org.apache.royale.utils.Language.as(this.element, createjs.Text);
  this.checkBoxLabel.text = this.text;
  this.checkBoxLabel["font"] = this.fontName;
  this.checkBoxLabel["color"] = color;
  this.checkBoxLabel.x = 45;
  this.checkBoxLabel.y = 40 / 2;
  this.checkMark.graphics.setStrokeStyle(1);
  this.checkMark.graphics.beginStroke('gray');
  this.checkMark.graphics.beginFill(this.selected ? fillColor : 'white');
  this.checkMark.graphics.drawRoundRect(0, 0, 32, 32, 6);
  this.checkMark.graphics.endFill();
  this.checkMark.graphics.endStroke();
  this.checkMark.x = 4;
  this.checkMark.y = 4;
  var /** @type {createjs.Stage} */ stage = this.checkBoxLabel.getStage();
  if (stage)
    stage.update();
};


/**
 * @asparam event The event.
 * @private
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.createjs.CheckBox.prototype.clickHandler = function(event) {
  this.selected = !this.selected;
};


org.apache.royale.createjs.CheckBox.prototype.get__text = function() {
  return org.apache.royale.utils.Language.as(this.model, org.apache.royale.core.IToggleButtonModel, true).text;
};


org.apache.royale.createjs.CheckBox.prototype.set__text = function(value) {
  org.apache.royale.utils.Language.as(this.model, org.apache.royale.core.IToggleButtonModel, true).text = value;
  this.redrawShape();
};


org.apache.royale.createjs.CheckBox.prototype.get__selected = function() {
  return org.apache.royale.utils.Language.as(this.model, org.apache.royale.core.IToggleButtonModel, true).selected;
};


org.apache.royale.createjs.CheckBox.prototype.set__selected = function(value) {
  org.apache.royale.utils.Language.as(this.model, org.apache.royale.core.IToggleButtonModel, true).selected = value;
  this.redrawShape();
  this.dispatchEvent(new org.apache.royale.events.Event("change"));
};


org.apache.royale.createjs.CheckBox.prototype.get__fontName = function() {
  return this._fontName;
};


org.apache.royale.createjs.CheckBox.prototype.set__fontName = function(value) {
  this._fontName = value;
  this.redrawShape();
};


Object.defineProperties(org.apache.royale.createjs.CheckBox.prototype, /** @lends {org.apache.royale.createjs.CheckBox.prototype} */ {
/**
  * @export
  * @type {string} */
text: {
get: org.apache.royale.createjs.CheckBox.prototype.get__text,
set: org.apache.royale.createjs.CheckBox.prototype.set__text},
/**
  * @export
  * @type {boolean} */
selected: {
get: org.apache.royale.createjs.CheckBox.prototype.get__selected,
set: org.apache.royale.createjs.CheckBox.prototype.set__selected},
/**
  * @export
  * @type {string} */
fontName: {
get: org.apache.royale.createjs.CheckBox.prototype.get__fontName,
set: org.apache.royale.createjs.CheckBox.prototype.set__fontName}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.createjs.CheckBox.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CheckBox', qName: 'org.apache.royale.createjs.CheckBox', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.createjs.CheckBox.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'text': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.CheckBox'},
        'selected': { type: 'Boolean', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.CheckBox'},
        'fontName': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.CheckBox'}
      };
    },
    methods: function () {return {};}
  };
};