/**
 * Generated by Apache Royale Compiler from org/apache/royale/createjs/graphics/Circle.as
 * org.apache.royale.createjs.graphics.Circle
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.createjs.graphics.Circle');

goog.require('org.apache.royale.createjs.graphics.GraphicShape');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.graphics.SolidColor');
goog.require('org.apache.royale.graphics.SolidColorStroke');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.createjs.graphics.GraphicShape}
 */
org.apache.royale.createjs.graphics.Circle = function() {
  org.apache.royale.createjs.graphics.Circle.base(this, 'constructor');
};
goog.inherits(org.apache.royale.createjs.graphics.Circle, org.apache.royale.createjs.graphics.GraphicShape);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.createjs.graphics.Circle', org.apache.royale.createjs.graphics.Circle);


/**
 * @private
 * @type {number}
 */
org.apache.royale.createjs.graphics.Circle.prototype._radius = 0;


/**
 * @asprivate
 * @royaleignorecoercion createjs.Shape
 *
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.0
 * @protected
 * @override
 */
org.apache.royale.createjs.graphics.Circle.prototype.redrawShape = function() {
  var /** @type {string} */ fillColor = null;
  var /** @type {number} */ fillAlpha = 1.0;
  if (this.fill != null) {
    fillAlpha = org.apache.royale.utils.Language.as(this.fill, org.apache.royale.graphics.SolidColor).alpha;
    fillColor = this.convertColorToString(org.apache.royale.utils.Language.as(this.fill, org.apache.royale.graphics.SolidColor).color, fillAlpha);
  }
  var /** @type {string} */ strokeColor = null;
  var /** @type {number} */ strokeWeight = 0;
  var /** @type {number} */ strokeAlpha = 1.0;
  if (this.stroke != null) {
    strokeWeight = org.apache.royale.utils.Language.as(this.stroke, org.apache.royale.graphics.SolidColorStroke).weight;
    strokeAlpha = org.apache.royale.utils.Language.as(this.stroke, org.apache.royale.graphics.SolidColorStroke).alpha;
    strokeColor = this.convertColorToString(org.apache.royale.utils.Language.as(this.stroke, org.apache.royale.graphics.SolidColorStroke).color, strokeAlpha);
  }
  var /** @type {createjs.Shape} */ circle = this.element;
  circle.graphics.setStrokeStyle(strokeWeight);
  circle.graphics.beginStroke(strokeColor);
  circle.graphics.beginFill(fillColor);
  circle.graphics.drawCircle(0, 0, this.radius);
  var /** @type {createjs.Stage} */ stage = circle.getStage();
  if (stage)
    stage.update();
};


org.apache.royale.createjs.graphics.Circle.prototype.get__radius = function() {
  return this._radius;
};


org.apache.royale.createjs.graphics.Circle.prototype.set__radius = function(value) {
  if (value != this._radius) {
    var /** @type {number} */ centerX = org.apache.royale.createjs.graphics.Circle.superClass_.get__x.apply(this) + this._radius;
    var /** @type {number} */ centerY = org.apache.royale.createjs.graphics.Circle.superClass_.get__y.apply(this) + this._radius;
    this._radius = value;
    this.x = centerX;
    this.y = centerY;
    this.dispatchEvent(new org.apache.royale.events.Event("radiusChanged"));
  }
};


org.apache.royale.createjs.graphics.Circle.prototype.get__x = function() {
  var /** @type {number} */ realX = org.apache.royale.createjs.graphics.Circle.superClass_.get__x.apply(this);
  return realX + this.radius;
};


org.apache.royale.createjs.graphics.Circle.prototype.set__x = function(value) {
  var /** @type {number} */ realX = value - this.radius;
  org.apache.royale.createjs.graphics.Circle.superClass_.set__x.apply(this, [ realX] );
};


org.apache.royale.createjs.graphics.Circle.prototype.get__y = function() {
  var /** @type {number} */ realY = org.apache.royale.createjs.graphics.Circle.superClass_.get__y.apply(this);
  return realY + this.radius;
};


org.apache.royale.createjs.graphics.Circle.prototype.set__y = function(value) {
  var /** @type {number} */ realY = value - this.radius;
  org.apache.royale.createjs.graphics.Circle.superClass_.set__y.apply(this, [ realY] );
};


Object.defineProperties(org.apache.royale.createjs.graphics.Circle.prototype, /** @lends {org.apache.royale.createjs.graphics.Circle.prototype} */ {
/**
  * @export
  * @type {number} */
radius: {
get: org.apache.royale.createjs.graphics.Circle.prototype.get__radius,
set: org.apache.royale.createjs.graphics.Circle.prototype.set__radius},
/**
  * @export
  * @type {number} */
x: {
get: org.apache.royale.createjs.graphics.Circle.prototype.get__x,
set: org.apache.royale.createjs.graphics.Circle.prototype.set__x},
/**
  * @export
  * @type {number} */
y: {
get: org.apache.royale.createjs.graphics.Circle.prototype.get__y,
set: org.apache.royale.createjs.graphics.Circle.prototype.set__y}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.createjs.graphics.Circle.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Circle', qName: 'org.apache.royale.createjs.graphics.Circle', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.createjs.graphics.Circle.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'radius': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.graphics.Circle'},
        'x': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.graphics.Circle'},
        'y': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.graphics.Circle'}
      };
    },
    methods: function () {return {};}
  };
};