/**
 * Generated by Apache Royale Compiler from org/apache/royale/createjs/tween/Sequence.as
 * org.apache.royale.createjs.tween.Sequence
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.createjs.tween.Sequence');

goog.require('org.apache.royale.createjs.tween.Effect');
goog.require('org.apache.royale.core.IDocument');
goog.require('org.apache.royale.utils.Language');



/**
 * Constructor 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 1.0.0
 * @constructor
 * @extends {org.apache.royale.createjs.tween.Effect}
 * @implements {org.apache.royale.core.IDocument}
 * @param {Object=} target
 */
org.apache.royale.createjs.tween.Sequence = function(target) {
  target = typeof target !== 'undefined' ? target : null;
  org.apache.royale.createjs.tween.Sequence.base(this, 'constructor', target);
  this._tweens = [];
  
};
goog.inherits(org.apache.royale.createjs.tween.Sequence, org.apache.royale.createjs.tween.Effect);


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.createjs.tween.Sequence', org.apache.royale.createjs.tween.Sequence);


/**
 * @private
 * @type {Array}
 */
org.apache.royale.createjs.tween.Sequence.prototype._tweens;


/**
 * @export
 * @param {org.apache.royale.createjs.tween.Effect} effect
 */
org.apache.royale.createjs.tween.Sequence.prototype.addEffect = function(effect) {
  this._tweens.push(effect);
};


/**
 * @private
 * @type {createjs.Tween}
 */
org.apache.royale.createjs.tween.Sequence.prototype._tween;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.createjs.tween.Sequence.prototype.document;


/**
 * @export
 * @param {Object} document
 * @param {string=} id
 */
org.apache.royale.createjs.tween.Sequence.prototype.setDocument = function(document, id) {
  id = typeof id !== 'undefined' ? id : null;
  this.document = document;
  
};


/**
 *  Causes the effects in the tween list to be played, one after the other. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 1.0.0
 *  @royaleignorecoercion createjs.Shape
 *  @royaleignorecoercion org.apache.royale.createjs.core.CreateJSBase
 * @export
 * @override
 */
org.apache.royale.createjs.tween.Sequence.prototype.play = function() {
  if (this.target != null) {
    this._actualTarget = this.document[this.target];
  }
  var /** @type {createjs.Shape} */ element = this._actualTarget.element;
  this._tween = createjs.Tween.get(element, {loop:this.loop});
  this._tween.setPaused(true);
  for (var /** @type {number} */ i = 0; i < this._tweens.length; i++) {
    var /** @type {org.apache.royale.createjs.tween.Effect} */ e = org.apache.royale.utils.Language.as(this._tweens[i], org.apache.royale.createjs.tween.Effect);
    var /** @type {Object} */ options = e.createTweenOptions();
    var /** @type {Function} */ useEasing = this.easing;
    if (e.easing != null)
      useEasing = e.easing;
    this._tween.to(options, e.duration, useEasing);
  }
  this._tween.setPaused(false);
  var /** @type {createjs.Stage} */ stage = element.getStage();
  createjs.Ticker.addEventListener("tick", stage);
  
};


org.apache.royale.createjs.tween.Sequence.prototype.get__tweens = function() {
  return this._tweens;
};


org.apache.royale.createjs.tween.Sequence.prototype.set__tweens = function(value) {
  this._tweens = value;
};


Object.defineProperties(org.apache.royale.createjs.tween.Sequence.prototype, /** @lends {org.apache.royale.createjs.tween.Sequence.prototype} */ {
/**
  * @export
  * @type {Array} */
tweens: {
get: org.apache.royale.createjs.tween.Sequence.prototype.get__tweens,
set: org.apache.royale.createjs.tween.Sequence.prototype.set__tweens}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.createjs.tween.Sequence.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Sequence', qName: 'org.apache.royale.createjs.tween.Sequence', kind: 'class' }], interfaces: [org.apache.royale.core.IDocument] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.createjs.tween.Sequence.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'tweens': { type: 'Array', access: 'readwrite', declaredBy: 'org.apache.royale.createjs.tween.Sequence'}
      };
    },
    methods: function () {
      return {
        'Sequence': { type: '', declaredBy: 'org.apache.royale.createjs.tween.Sequence', parameters: function () { return [  { index: 1, type: 'Object', optional: true } ]; }},
        'addEffect': { type: 'void', declaredBy: 'org.apache.royale.createjs.tween.Sequence', parameters: function () { return [  { index: 1, type: 'org.apache.royale.createjs.tween.Effect', optional: false } ]; }},
        'setDocument': { type: 'void', declaredBy: 'org.apache.royale.createjs.tween.Sequence', parameters: function () { return [  { index: 1, type: 'Object', optional: false },{ index: 2, type: 'String', optional: true } ]; }},
        'play': { type: 'void', declaredBy: 'org.apache.royale.createjs.tween.Sequence'}
      };
    },
    metadata: function () { return [  ]; }
  };
};